#! /bin/sh
#
# Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
#pragma ident	"@(#)postinstall	1.2	07/04/27 SMI"
#

#
# install the Sun Crypto Accelerator 1000 device drivers.
#

PATH="/usr/bin:/usr/sbin:${PATH}"
export PATH

# Add hardware provider section for the dca driver
# to /etc/crypto/kcf.conf

pkg_start="# Start $PKGINST"
pkg_end="# End $PKGINST"
kcfconf=${BASEDIR}/etc/crypto/kcf.conf
tmpfile=/tmp/$$kcfconf
error=no

#
# If /etc/crypto/kcf.conf doesn't exist, bail immediately
#
if [ ! -f "$kcfconf" ]
then
	echo "$0: ERROR - $kcfconf doesn't exist"
        exit 2
fi

#
# If the package has been already installed, remove old entries
#
start=0
end=0
egrep -s "$pkg_start" $kcfconf && start=1
egrep -s "$pkg_end" $kcfconf && end=1

if [ $start -ne $end ] ; then
	echo "$0: missing Start or End delimiters for $PKGINST in $kcfconf."
	echo "$0: $kcfconf may be corrupted and was not updated."
	error=yes
	exit 2
fi

# to preserve the gid
cp -p $kcfconf $tmpfile || error=yes
if [ $start -eq 1 ]
then
	sed -e "/$pkg_start/,/$pkg_end/d" $kcfconf > $tmpfile || error=yes
fi

#
# Append the delimiters for this package
#
echo "$pkg_start driver_names=dca" >> $tmpfile || error=yes
echo "$pkg_end" >> $tmpfile || error=yes

#
# Install the updated config file and clean up the tmp file
#
if [ "$error" = no ]
then
	mv $tmpfile $kcfconf || error=yes
fi
rm -f $tmpfile

#
# All done, if any of the steps above fail, report the error
#
if [ "$error" = yes ]
then
	echo "$0: ERROR - failed to update $kcfconf."
        exit 2
fi

NAMEMAJOR="${BASEDIR}/etc/name_to_major"

#
# Is the hardware there?
#
check_hardware()
{
	for i in "pci14e4,5820" "pci14e4,5821" "pci14e4,5822" "pci14e4,5825" \
		"pci108e,5454" "pci108e,5455" "pci108e,5456" "pci108e,5457"
	do
		prtconf -pv | egrep -s "$i"
		if [ $? -eq 0 ]
		then
			return 1
		fi
	done
	return 0
}

hw_opt=
check_hardware
if [ $? -eq 0 ]
then
	hw_opt="-n"
fi

if [ "${BASEDIR:=/}" = "/" ]
then
	ADD_DRV="/usr/sbin/add_drv $hw_opt"
else
	ADD_DRV="/usr/sbin/add_drv $hw_opt -b ${BASEDIR}"
fi

grep -w dca ${NAMEMAJOR} > /dev/null 2>&1
if [ $? -ne 0 ]
then
    $ADD_DRV -i '"pci14e4,5820" "pci14e4,5821" "pci14e4,5822" "pci14e4,5825" "pci108e,5454" "pci108e,5455" "pci108e,5456"  "pci108e,5457"' \
	dca || exit 1
fi

exit 0
